Scriptname wizHagravenHangingBallScript extends ObjectReference  


Actor Property PlayerREF Auto
Ingredient Property Taproot Auto
GlobalVariable Property wizDynamicThingsEnabled Auto 
GlobalVariable Property wizOptionMiscsEnabled Auto 

int Harvested

Event OnActivate(ObjectReference akActionRef)
	akActionRef.additem(Taproot,3)
	self.disable()
	Harvested = 1
EndEvent

Event OnReset()
	;Does this even happen and when?
	;Even if disabled must reset harvest status
	Harvested = 0 
	if wizDynamicThingsEnabled.getvalueint() == 1 && wizOptionMiscsEnabled.getvalueint() == 1
		self.enable()
	endIf
endEvent

Event OnLoad()
	if wizDynamicThingsEnabled.getvalueint() == 1 && wizOptionMiscsEnabled.getvalueint() == 1
		if Harvested == 1
			debug.notification("Onload disabled")
			self.disable()
		Else
			self.enable()
		EndIf
	endIf
EndEvent