Scriptname wizHayBale01StaticScript extends ObjectReference  

Actor Property PlayerREF Auto
Actor Property ArngeirREF Auto
FormList property wizStrawList auto
FormList Property wizSafeContainerList Auto
GlobalVariable Property wizDynamicThingsEnabled Auto 
GlobalVariable Property wizOptionMiscsEnabled Auto 
MiscObject Property wizStraw Auto
wizDTCompatibility Property Compatibility Auto
GlobalVariable Property wizOptionDTResetTime Auto

Bool ItemAdded
Float Respawn


Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	if akSourceContainer == PlayerREF ;Only check for the player!
		if !(wizStrawList .HasForm(akBaseItem))
			Debug.Notification("Sorry straw only!")
			PlayerREF.additem(akBaseItem, aiItemCount, true)
			self.removeitem(akBaseItem, aiItemCount)
		else
			if ItemAdded == False
				ItemAdded= TRUE
				if !wizSafeContainerList.HasForm(self)
					wizSafeContainerList.AddForm(self)
;					debug.notification(wizSafeContainerList.GetSize())
				endIf
				debug.notification("Dynamic Things: This hay bale is safe for storage")
			endIf			
		endIf
	endIf
endEvent

Event OnCellDetach()
	Respawn = Utility.GetCurrentGameTime()
endEvent

Event OnCellAttach()
	if ItemAdded != TRUE
		if utility.getCurrentGameTime() >= (Respawn + (wizOptionDTResetTime.getvalue() as float))
			Self.disable()
			Self.delete()
			Return
		endIf
	endIf

	if self.getNumItems() == 0
		self.Disable()
	endIf
endEvent

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	;Disable this pile if the player takes all of the straw from it.
	if akDestContainer != None 
		if self.getNumItems() == 0
			Game.DisablePlayerControls()			;Force player out of the hay bale inventory
			Game.EnablePlayerControls()
			itemAdded=FALSE
			self.Disable()
		endif
	endIf
endEvent

Event OnActivate(ObjectReference akActionRef)
	if akActionRef == Game.GetPlayer()
		if ItemAdded == TRUE
			if !wizSafeContainerList.HasForm(self)
				wizSafeContainerList.AddForm(self)
;				debug.notification(wizSafeContainerList.GetSize())
			endIf
			debug.notification("Dynamic Things: This hay bale is safe for storage")
		endIf
	endIf
endEvent

event onReset()
	;Not used any more
endEvent

